#!/usr/bin/perl
$file_path = '/usr/local/vhosts/your_directory/';
$max_records = 200;

##############################################################################
# QmakeCGITop.pl                Version 1.0                                  #
# Copyright 2001 Luca Galli     info@lucagalli.net                           #
# Last Modified: 29/09/2001                                                  #
# The latest version of this script can be found at http://www.lucagalli.net #
##############################################################################
# If you run into any problems while trying to configure this scripts,       #
# read the document "How to install a Perl script" at:                       #
#        http://www.lucagalli.net/eng/quizfaber/perl-install.htm             #
# I hope I will be able to help you solve your problems.                     #
##############################################################################
# QmakeCGITop.pl store quizzes marks on archive file placed on web server.   #
# Each single quiz, that runs on a single PC in a Internet/Intranet,         #
# automatically sends its results through the net to web server.             #
# Then the server calls a script, called 'QmakeCGITop.pl' that collect this  # 
# marks into a archive file.                                                 #
# For each data sent from a single quiz, a text line is added to top chart   #
# file.                                                                      #
#                                                                            #
# How to use this script can also be read on QuizFaber Help                  #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2001 Luca Galli                                                  #
#                                                                            #
# QmakeCGITop.pl be used and modified free of charge by anyone so long as    #
# this copyright notice and the comments above remain intact.                #
# Selling the code for this program is forbidden.                            #
#                                                                            #
# THIS PROGRAM IS GIVEN "AS IS" AND WITHOUT WARRANTIES AS TO PERFORMANCE OR  #
# MERCHANTABILITY OR ANY OTHER WARRANTIES WHETHER EXPRESSED OR IMPLIED.      #
# NO WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.                #
# IN NO EVENT SHALL LUCA GALLI BE LIABLE FOR ANY DAMAGES WHATSOEVER          #
# INCLUDING DIRECT, INDIRECT, INCIDENTAL, CONSEQUENTIAL, LOSS OF BUSINESS    #
# PROFITS OR SPECIAL DAMAGES, EVEN IF LUCA GALLI BEEN ADVISED OF THE         #
# POSSIBILITY OF SUCH DAMAGES.                                               #
##############################################################################

use CGI;
use Time::localtime;

$cgivars = new CGI;

#---------------------------
# Constant declarations
#---------------------------

$QMAKECGITOP_CODE_VERS = 1;
$SEPARATOR             = "\t";
$LOG_TEMPFILE          = $file_path."temp.log";

#---------------------------
# Subroutine SetLanguage() 
#---------------------------
sub SetLanguage
{
 my $lang = shift;

 if (($lang eq 'eng')||($lang eq '')) {
   $QMAKECGI_SERVER_ERROR    = 'CGI Script error';
   $QMAKECGI_STR_SERVER_ERR  = 'The CGI script named QmakeCGITop.pl has produced the follow error';
   $QMAKECGI_NO_LOGFILE      = 'unable to retrive archive file name';
   $QMAKECGI_NO_OPEN_LOGFILE = 'writing error in archive file';
   $QMAKECGI_MSG_OK    = 'Quiz result has been stored successfully';
 }
 elsif ($lang eq 'ita') {
   $QMAKECGI_SERVER_ERROR    = 'Errore script CGI';
   $QMAKECGI_STR_SERVER_ERR  = 'Lo script CGI QmakeCGITop.pl ha generato il seguente errore';
   $QMAKECGI_NO_LOGFILE      = 'impossibile determinare il nome del file di archivio';
   $QMAKECGI_NO_OPEN_LOGFILE = 'errore nella scrittura del file di archivio';
   $QMAKECGI_MSG_OK    = 'I risultati del quiz sono stati memorizzati correttamente.';
 }
}

#---------------------------
# Main   
#---------------------------

  $lang = $cgivars->param('lang'); 
  SetLanguage($lang);

  $vers = $cgivars->param('vers'); 

  $archive = $cgivars->param('logfile');
  if ($archive eq '') {
    printError($QMAKECGI_NO_LOGFILE);
    die();
  }

  $name = $cgivars->param('user');
  $mark = $cgivars->param('mark');

  if (loadRecords()==0) {
    printError($QMAKECGI_NO_OPEN_LOGFILE);
    die();
  }

  printResult();


#---------------------------
# Subroutine printError()   
#---------------------------
sub printError
{
  print $cgivars->header;
  print $cgivars->start_html($QMAKECGI_SERVER_ERROR);

  print <<TEXT_ERR      
      <TABLE><TD BGCOLOR='#B7B7B7'><FONT FACE='Arial'>$QMAKECGI_SERVER_ERROR</FONT></TD></TABLE>
      <FONT FACE='Arial' SIZE='-1'>$QMAKECGI_STR_SERVER_ERR:<BR>
      <B>$_[0]</B>
      </FONT>
      <CENTER><BR><FORM><INPUT TYPE='BUTTON' VALUE='$QMAKECGI_ENDQUIZ' OnClick='top.close()' style='font-family:Arial'></FORM></CENTER>
TEXT_ERR
;
  print $cgivars->end_html;
}


#---------------------------
# Subroutine printResult()   
#---------------------------
sub printResult
{
  print $cgivars->header;
  print "<HTML><HEAD></HEAD><BODY OnLoad='window.close()'>";
  print $cgivars->end_html;
}

#---------------------------
# Subroutine saveRecord()   
#---------------------------
sub saveRecord 
{
  my $keyname;

  print OUT_LOG ":$QMAKECGITOP_CODE_VERS".$SEPARATOR;

  $loctim = localtime();
  $day = (($loctim->mday()<10)?'0':'').$loctim->mday();
  $month = (($loctim->mon()<9)?'0':'').($loctim->mon()+1);

  print OUT_LOG $day."-".$month."-".($loctim->year + 1900).$SEPARATOR;

  @vett = split (/,/,$name);
  $keyname = $vett[0];

  print OUT_LOG $keyname.$SEPARATOR;
  print OUT_LOG $mark.$SEPARATOR;
  print OUT_LOG "\n";
}


#---------------------------
# Subroutine saveRecord()   
#---------------------------
sub loadRecords 
{
  my $n = 0;
  my $is_placed = 0;

  $filename = $file_path.$archive;

  if (open (IN_LOG, "+<$filename")==0) {
    if (open (OUT_LOG, "+>$filename")==0) {
      return 0;
    }
    saveRecord();
    close(OUT_LOG);
    return 1;
  }
  if (open (OUT_LOG, "+>$LOG_TEMPFILE")==0) {
    return 0;
  }

  while ($line = <IN_LOG>) {
    @elems = split (/\t/,$line);
    if (($mark > $elems[3])&&($is_placed==0)) {
      saveRecord();
      $is_placed=1;
      $n++;
      if ($n >= $max_records) {
        break;
      }
    }
    print OUT_LOG $line;
    $n++;
    if ($n >= $max_records) {
      break;
    }
  }

  if ($is_placed==0) {
    saveRecord();
  }

  close(IN_LOG);
  close(OUT_LOG);

  unlink $filename;
  rename ($LOG_TEMPFILE,$filename);

  return 1;
}
