#!/usr/bin/perl
$file_path = '/usr/local/vhosts/your_directory/';

##############################################################################
# QmakeCGI.pl                   Version 1.1                                  #
# Copyright 2001 Luca Galli     info@lucagalli.net                           #
# Last Modified: 29/09/2001                                                  #
# The latest version of this script can be found at http://www.lucagalli.net #
##############################################################################
# If you run into any problems while trying to configure this scripts,       #
# read the document "How to install a Perl script" at:                       #
#        http://www.lucagalli.net/eng/quizfaber/perl-install.htm             #
# I hope I will be able to help you solve your problems.                     #
##############################################################################
# QmakeCGI.pl store quizzes results on archive file placed on web server.    #
# Each single quiz, that runs on a single PC in a Internet/Intranet,         #
# automatically sends its results through the net to web server.             #
# Then the server calls a script, called 'QmakeCGI.pl' that collect this     # 
# results into a archive file.                                               #
# For each data sent from a single quiz, a text line is added to archive file#
# To inquire into an archive file, QuizFaber, for every quiz built,          #
# automatically generate a HTML form page that, when the page is opened,     #
# send a request to server.                                                  #
# Then the server calls the second script 'QmakeCGIQuery.pl' that read the   #
# archive file and shows, as HTML page, the query results (in other words,   #
# the quiz results that satisfied the query criterion).                      #
#                                                                            #
# How to use this script can also be read on QuizFaber Help                  #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2001 Luca Galli                                                  #
#                                                                            #
# QmakeCGI.pl be used and modified free of charge by anyone so long as       #
# this copyright notice and the comments above remain intact.                #
# Selling the code for this program is forbidden.                            #
#                                                                            #
# THIS PROGRAM IS GIVEN "AS IS" AND WITHOUT WARRANTIES AS TO PERFORMANCE OR  #
# MERCHANTABILITY OR ANY OTHER WARRANTIES WHETHER EXPRESSED OR IMPLIED.      #
# NO WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.                #
# IN NO EVENT SHALL LUCA GALLI BE LIABLE FOR ANY DAMAGES WHATSOEVER          #
# INCLUDING DIRECT, INDIRECT, INCIDENTAL, CONSEQUENTIAL, LOSS OF BUSINESS    #
# PROFITS OR SPECIAL DAMAGES, EVEN IF LUCA GALLI BEEN ADVISED OF THE         #
# POSSIBILITY OF SUCH DAMAGES.                                               #
##############################################################################

use CGI;
use Time::localtime;

$cgivars = new CGI;

#---------------------------
# Constant declarations
#---------------------------

$QMAKECGI_CODE_VERS = 3;
$SEPARATOR = "\t";

$QMAKE_HIDDENQST = \0;
$QMAKE_MULTIANS  = \1;
$QMAKE_BOOLEAN   = \2;
$QMAKE_OPENANS   = \3;
$QMAKE_FILLGAP   = \4;
$QMAKE_MATCHING  = \5;
$QMAKE_MULTIANSPT = \101;


#---------------------------
# Subroutine SetLanguage() 
#---------------------------
sub SetLanguage
{
 my $lang = shift;

 if (($lang eq 'eng')||($lang eq '')) {
   $QMAKECGI_SERVER_ERROR    = 'CGI Script error';
   $QMAKECGI_STR_SERVER_ERR  = 'The CGI script named QmakeCGI.pl has produced the follow error';
   $QMAKECGI_NO_VERS         = "Warning: quiz version number is greater than version $QMAKECGI_CODE_VERS of QmakeCGI.pl. You should update both QmakeCGI.pl and QmakeCGIQuery.pl on your server.";
   $QMAKECGI_NO_LOGFILE      = 'unable to retrive archive file name';
   $QMAKECGI_NO_OPEN_LOGFILE = 'writing error in archive file';

   $QMAKECGI_QUIZ_RES  = 'Quiz result';
   $QMAKECGI_NUM_QUEST = 'Number of questions';
   $QMAKECGI_USERNAME  = 'Candidate name';
   $QMAKECGI_RIGHT_ANS = 'Right answers';
   $QMAKECGI_WRONG_ANS = 'Wrong answers';
   $QMAKECGI_NO_ANS    = 'Unmarked questions';
   $QMAKECGI_TIME      = 'Time elapsed';
   $QMAKECGI_MARK      = 'MARK';
   $QMAKECGI_ENDQUIZ   = 'Close';
   $QMAKECGI_STORE_RES = 'Stored data';
   $QMAKECGI_MSG_OK    = 'Quiz result has been stored successfully';
 }
 elsif ($lang eq 'ita') {
   $QMAKECGI_SERVER_ERROR    = 'Errore script CGI';
   $QMAKECGI_STR_SERVER_ERR  = 'Lo script CGI QmakeCGI.pl ha generato il seguente errore';
   $QMAKECGI_NO_VERS         = "Attenzione: numero di versione del quiz e' piu' grande della versione $QMAKECGI_CODE_VERS di QmakeCGI.pl. E' necessario usare una versione piu' recente di QmakeCGI.pl e QmakeCGIQuery.pl sul vostro server.";
   $QMAKECGI_NO_LOGFILE      = 'impossibile determinare il nome del file di archivio';
   $QMAKECGI_NO_OPEN_LOGFILE = 'errore nella scrittura del file di archivio';

   $QMAKECGI_QUIZ_RES  = 'Risultati del quiz';
   $QMAKECGI_NUM_QUEST = 'Numero di domande';
   $QMAKECGI_USERNAME  = 'Nome esaminando';
   $QMAKECGI_RIGHT_ANS = 'Risposte corrette';
   $QMAKECGI_WRONG_ANS = 'Risposte errate';
   $QMAKECGI_NO_ANS    = 'Domande non valutate';
   $QMAKECGI_TIME      = 'Tempo impiegato';
   $QMAKECGI_MARK      = 'VOTO';
   $QMAKECGI_ENDQUIZ   = 'Chiudi';
   $QMAKECGI_STORE_RES = 'Dati memorizzati';
   $QMAKECGI_MSG_OK    = 'I risultati del quiz sono stati memorizzati correttamente.';
 }
}

#---------------------------
# Main   
#---------------------------

  $lang = $cgivars->param('lang');
  SetLanguage($lang);

  $vers = $cgivars->param('vers'); 
  if (($vers eq '')||($vers =~ m/v/)) {
    #old versions:
    $vers = 1;
  }

  $archive = $cgivars->param('logfile');
  if ($archive eq '') {
    printError($QMAKECGI_NO_LOGFILE);
    die();
  }

  if (saveRecord()==0) {
    printError($QMAKECGI_NO_OPEN_LOGFILE);
    die();
  }

  printResult();


#---------------------------
# Subroutine printError()   
#---------------------------
sub printError
{
  print $cgivars->header;
  print $cgivars->start_html($QMAKECGI_SERVER_ERROR);
  print <<TEXT_ERR      
      <TABLE><TD BGCOLOR='#B7B7B7'><FONT FACE='Arial'>$QMAKECGI_SERVER_ERROR</FONT></TD></TABLE>
      <FONT FACE='Arial' SIZE='-1'>$QMAKECGI_STR_SERVER_ERR:<BR>
      <B>$_[0]</B>
      </FONT>
      <CENTER><BR><FORM><INPUT TYPE='BUTTON' VALUE='$QMAKECGI_ENDQUIZ' OnClick='top.close()' style='font-family:Arial'></FORM></CENTER>
TEXT_ERR
;
  print $cgivars->end_html;
}


#---------------------------
# Subroutine printResult()   
#---------------------------
sub printResult
{
  my $maxmark      = $cgivars->param('maxvoto');
  my $nc           = $cgivars->param('nc');
  my $ns           = $cgivars->param('ns');
  my $nr           = $cgivars->param('nr');
  my $nQuest       = $cgivars->param('nQuest');
  my $nHiddenQuest = $cgivars->param('nQHidden');
  my $validQuest   = $nQuest-$nHiddenQuest; 
  my $mark         = $cgivars->param('mark');
  my $userName     = $cgivars->param('user');
  my $time         = $cgivars->param('time');
  my $valuation    = $cgivars->param('valuation');
  my $encrypt      = $cgivars->param('encrypt');

  @keyname = split(/,/,$userName);

  print $cgivars->header;
  print $cgivars->start_html($QMAKECGI_QUIZ_RES);

  if ($encrypt) {
    $nc = $ns = $mark = '-';
  }

  if ($vers > $QMAKECGI_CODE_VERS) {
    print "<FONT FACE='Arial' SIZE='-2' COLOR='#FF0000'>$QMAKECGI_NO_VERS</FONT><BR><BR>";
  }

  if ($valuation) {

    print <<TEXT_HEAD
      <P>
      <TABLE border=0><TD><TABLE border=0 cellpadding=1>
      <TR><TD bgcolor='#000000'><TABLE cellpadding=3 border=0 cellspacing=1><TR>

      <TD COLSPAN=2 BGCOLOR='#B7B7B7' ALIGN='CENTER'>
      <FONT FACE='Arial' SIZE='-1'><B>$QMAKECGI_STORE_RES</B></FONT></TD>
      <TR>
TEXT_HEAD
;

    print "<TR><TD BGCOLOR='#FFFFFF' ALIGN=RIGHT NOWRAP><FONT FACE='Arial' SIZE='-1'>$QMAKECGI_NUM_QUEST :</FONT></TD>";
    print "<TD BGCOLOR='#FFFFFF' ALIGN=LEFT NOWRAP><FONT FACE='Arial' SIZE='-1'>$validQuest</FONT></TD></TR>";

    if ((userName ne "anonymous")&&(userName ne "anonimo")) {
      print "<TR><TD BGCOLOR='#FFFFFF' ALIGN=RIGHT NOWRAP><FONT FACE='Arial' SIZE='-1'>$QMAKECGI_USERNAME :</FONT></TD>";
      print "<TD BGCOLOR='#FFFFFF' ALIGN=LEFT NOWRAP><FONT FACE='Arial' SIZE='-1'>$keyname[0]</FONT></TD></TR>";
    }

    print "<TR><TD BGCOLOR='#FFFFFF' ALIGN=RIGHT NOWRAP><FONT FACE='Arial' SIZE='-1'>$QMAKECGI_RIGHT_ANS :</FONT></TD>";
    print "<TD BGCOLOR='#FFFFFF' ALIGN=LEFT NOWRAP><FONT FACE='Arial' SIZE='-1'>$nc</FONT></TD></TR>";

    print "<TR><TD BGCOLOR='#FFFFFF' ALIGN=RIGHT NOWRAP><FONT FACE='Arial' SIZE='-1'>$QMAKECGI_WRONG_ANS :</FONT></TD>";
    print "<TD BGCOLOR='#FFFFFF' ALIGN=LEFT NOWRAP><FONT FACE='Arial' SIZE='-1'>$ns</FONT></TD></TR>";

    if ($nr>0) {
      print "<TR><TD BGCOLOR='#FFFFFF' ALIGN=RIGHT NOWRAP><FONT FACE='Arial' SIZE='-1'>$QMAKECGI_NO_ANS :</FONT></TD>";
      print "<TD BGCOLOR='#FFFFFF' ALIGN=LEFT NOWRAP><FONT FACE='Arial' SIZE='-1'>$nr</FONT></TD></TR>";
    }

    print <<TEXT_FOOTER
      <TR><TD BGCOLOR='#FFFFFF' ALIGN=RIGHT NOWRAP><FONT FACE='Arial' SIZE='-1'>$QMAKECGI_TIME :</FONT></TD>
          <TD BGCOLOR='#FFFFFF' ALIGN=LEFT><FONT FACE='Arial' SIZE='-1'>$time</FONT></TD></TR>
      <TR><TD BGCOLOR='#FFFFFF' ALIGN=RIGHT NOWRAP><FONT FACE='Arial' SIZE='-1'>$QMAKECGI_MARK :</FONT></TD>
          <TD BGCOLOR='#FFFFFF' ALIGN=LEFT><FONT FACE='Arial' SIZE='-1'>$mark / $maxmark</FONT></TD></TR>
      </TR></TABLE></TD></TR></TABLE></TD>

      <TR><TD COLSPAN=2 bgcolor='#FFFFFF' ALIGN=CENTER>
      <FORM><INPUT TYPE='BUTTON' VALUE='$QMAKECGI_ENDQUIZ' OnClick='top.close()' style='font-family:Arial'></FORM>
      </TD></TR>
      </TABLE>
TEXT_FOOTER
;
  }
  else {
    print "<CENTER><FONT FACE='Arial' SIZE='-1'>$QMAKECGI_MSG_OK</FONT>";
    print "<FORM><INPUT TYPE='BUTTON' VALUE='$QMAKECGI_ENDQUIZ' OnClick='top.close()' style='font-family:Arial'></FORM></CENTER>";
  }

  print $cgivars->end_html;
}

#---------------------------
# Subroutine saveRecord()   
#---------------------------
sub saveRecord 
{
  my $nQuest       = $cgivars->param('nQuest');
  my $nHiddenQuest = $cgivars->param('nQHidden');
  my $validQuest   = $nQuest-$nHiddenQuest; 

  $filename = $file_path.$archive;

  if (open (FP, "+>>$filename")==0) {
    return 0;
  }

  print FP ":$QMAKECGI_CODE_VERS".$SEPARATOR;
  print FP $cgivars->param('encrypt').$SEPARATOR;
  print FP $cgivars->param('titleQuiz').$SEPARATOR;
  print FP $cgivars->param('user').$SEPARATOR;

  $loctim = localtime();
  $day = (($loctim->mday()<10)?'0':'').$loctim->mday();
  $month = (($loctim->mon()+1<10)?'0':'').($loctim->mon()+1);

  print FP $day."-".$month."-".($loctim->year + 1900).$SEPARATOR;

  print FP $nQuest.$SEPARATOR;
  print FP $cgivars->param('maxvoto').$SEPARATOR;
  print FP $cgivars->param('timeout').$SEPARATOR;
  print FP $cgivars->param('time').$SEPARATOR;
  print FP $cgivars->param('nc').$SEPARATOR;
  print FP $cgivars->param('ns').$SEPARATOR;
  print FP $cgivars->param('nr').$SEPARATOR;
  print FP $cgivars->param('mark').$SEPARATOR;
  print FP $cgivars->param('author').$SEPARATOR;
  print FP $cgivars->param('argument').$SEPARATOR;

  for ($i=0; $i<$nQuest; $i++) {
    $name = "datastore".($i+1);
    $kind = $cgivars->param($name);

    if (($kind == $$QMAKE_MULTIANS)||
        ($kind == $$QMAKE_MULTIANSPT)||
        ($kind == $$QMAKE_BOOLEAN)||
        ($kind == $$QMAKE_MATCHING)||
        ($kind == $$QMAKE_FILLGAP)) {

        $name = "weight".($i+1);
        $weight = $cgivars->param($name);
        $name = "risposta".($i+1);
        $value = $cgivars->param($name);
        $name = "score".($i+1);
        $value2 = $cgivars->param($name);

        print FP $kind.$SEPARATOR.$weight.$SEPARATOR.$value.$SEPARATOR.$value2.$SEPARATOR;
    }
    elsif ($kind == $$QMAKE_OPENANS) {

        $name = "risposta".($i+1);
        $value = $cgivars->param($name);       
        $value =~ s/[\n]/<BR>/g;
        $value =~ s/[\r]/ /g;
        print FP $kind.$SEPARATOR.$weight.$SEPARATOR.$value.$SEPARATOR;
    }
    else {
        # QMAKE_HIDDENQST :
        print FP $kind.$SEPARATOR;
    }
  }
  print FP "\n";
  close(FP);

  return 1;
}

