#!/usr/bin/perl
$file_path = '/usr/local/vhosts/your_directory/';
$image_path = 'http://www.your_domain.com/images/';

##############################################################################
# QmakeCGIQuery.pl              Version 2.3                                  #
# Copyright 2001 Luca Galli     info@lucagalli.net                           #
# Last Modified: 25/04/2005                                                  #
# The latest version of this script can be found at http://www.lucagalli.net #
##############################################################################
# If you run into any problems while trying to configure this scripts,       #
# read the document "How to install a Perl script" at:                       #
#        http://www.lucagalli.net/eng/quizfaber/perl-install.htm             #
# I hope I will be able to help you solve your problems.                     #
##############################################################################
# QmakeCGI.pl store quizzes results on archive file placed on web server.    #
# Each single quiz, that runs on a single PC in a Internet/Intranet,         #
# automatically sends its results through the net to web server.             #
# Then the server calls a script, called 'QmakeCGI.pl' that collect this     # 
# results into a archive file.                                               #
# For each data sent from a single quiz, a text line is added to archive file#
# To inquire into an archive file, QuizFaber, for every quiz built,          #
# automatically generate a HTML form page that, when the page is opened,     #
# send a request to server.                                                  #
# Then the server calls the second script 'QmakeCGIQuery.pl' that read the   #
# archive file and shows, as HTML page, the query results (in other words,   #
# the quiz results that satisfied the query criterion).                      #
#                                                                            #
# How to use this script can also be read on QuizFaber Help                  #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2001-2005 Luca Galli                                             #
#                                                                            #
# QmakeCGIQuery.pl be used and modified free of charge by anyone so long as  #
# this copyright notice and the comments above remain intact.                #
# Selling the code for this program is forbidden.                            #
#                                                                            #
# THIS PROGRAM IS GIVEN "AS IS" AND WITHOUT WARRANTIES AS TO PERFORMANCE OR  #
# MERCHANTABILITY OR ANY OTHER WARRANTIES WHETHER EXPRESSED OR IMPLIED.      #
# NO WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.                #
# IN NO EVENT SHALL LUCA GALLI BE LIABLE FOR ANY DAMAGES WHATSOEVER          #
# INCLUDING DIRECT, INDIRECT, INCIDENTAL, CONSEQUENTIAL, LOSS OF BUSINESS    #
# PROFITS OR SPECIAL DAMAGES, EVEN IF LUCA GALLI BEEN ADVISED OF THE         #
# POSSIBILITY OF SUCH DAMAGES.                                               #
##############################################################################

use CGI;

$cgivars = new CGI;

#---------------------------
# Constant declarations                                                     
#---------------------------

$LOG_TEMPFILE = $file_path."temp.log";

$COLOR1 = 'CFCFCF';
$COLOR2 = 'AFAFAF';

$QMAKE_MULTIANS  = \1;
$QMAKE_BOOLEAN   = \2;
$QMAKE_OPENANS   = \3;
$QMAKE_FILLGAP   = \4;
$QMAKE_MATCHING  = \5;
$QMAKE_MULTIANSPT = \101;

#---------------------------
# Subroutine SetLanguage() 
#---------------------------
sub SetLanguage
{
 my $lang = shift;

 if (($lang eq 'eng')||($lang eq '')) {

   $QMAKECGI_SERVER_ERROR     = 'CGI Script error';
   $QMAKECGI_STR_SERVER_ERR   = 'The CGI script named QmakeCGIQuery.pl has produced the follow error';
   $QMAKECGIQ_MODE_MISSING    = "parameter 'mode' missing";
   $QMAKECGIQ_LOGFILE_MISSING = "archive file name missing";
   $QMAKECGIQ_CMD_UNKNOWN     = "unknown request to CGI script QmakeCGIQuery.pl";
   $QMAKECGIQ_NO_OPEN_FILE    = "unable to open archive file";
   $QMAKECGIQ_NO_WRITE_FILE   = "unable to update archive file";
   $QMAKECGIQ_NO_DELETE_RECORDS = "unable to delete record from archive";
   $QMAKECGIQ_ASK_DELETE      = "Do you really want delete records from archive ?";
   $QMAKECGIQ_QUERY_REPORT    = "Search Results";
   $QMAKECGIQ_NO_RECORD_FOUND = "Sorry, your search returned 0 results";
   $QMAKECGIQ_DELETED         = "Found and deleted";
  
   $DATE          = "date";
   $QUESTIONS     = "questions";
   $TIME          = "time";
   $TIME_ELAPSED  = "time elapsed";
   $MARK          = "mark";
   $RIGHT_ANSWERS = "right answers";
   $WRONG         = "wrong";
   $UNMARKED      = "unmarked";
   $LIST_OF_ANSWERS = "List of answers";
   $AUTHOR        = "Author";
   $EXCLUDED      = "Not included";
   $QUIZ_TITLE    = "Quiz Title";
   $ARCHIVE_NAME  = "Archive file name";
   $STUDENT_NAME  = "Student Name";
   $FROM_DATE     = "From date";
   $TO_DATE       = "To date";
   $QUERY_RESULT  = "Query result";
   $SEARCH        = "Search";
   $CLOSE         = "Close";
   $HELP          = "Help";
   $FOUND         = "Found";
   $RESULTS       = "Results";
   $RECORDS_UP_TO = "Display up to records:";
   $RECORDS       = "records";
   $DELETE        = "Delete";
   $PRINT         = "Print";
   $PRINT_MSG     = "Please use FILE menu, then PRINT...";
   $PASSWORD      = "Password";
   $QUESTION      = "Question";
   $ANSWERS       = "Answers";
   $CORRECT_ANS   = "Correct answers";
   $GLOB_STATS    = "Global statistics";
   $MAX           = "Maximum value";
   $MIN           = "Minimum value";
   $MEAN          = "Mean value";
   $STD_DEV       = "Standard deviation";
   $EXACT_MATCH   = "Exact matching";
   $ENABLE_GLOB_STATS = 'Enable global statistics (time, mark)';
   $WEIGHT        = "Weight";
   $POINTS        = "points";
   $ON            = "on";
   $HOURS_MINUTES = "hr:min:sec";
   $SHORT_REPORT  = "Short report";
   $BASE_10       = "referred to base 10";
   $NEXT_RESULTS  = "Next results >>";
   $PREV_RESULTS  = "<< Previous results";
 }
 elsif ($lang eq 'ita') {
   $QMAKECGI_SERVER_ERROR     = 'Errore Script CGI';
   $QMAKECGI_STR_SERVER_ERR   = 'Lo script QmakeCGIQuery.pl ha prodotto il seguente errore';
   $QMAKECGIQ_MODE_MISSING    = "parametro selezione modo non specificato";
   $QMAKECGIQ_LOGFILE_MISSING = "nome del file di archivio non specificato";
   $QMAKECGIQ_CMD_UNKNOWN     = "richiesta sconosciuta allo script QmakeCGIQuery.pl";
   $QMAKECGIQ_NO_OPEN_FILE    = "errore nella apertura del file di archivio";
   $QMAKECGIQ_NO_WRITE_FILE   = "errore aggiornamento del file di archivio";
   $QMAKECGIQ_NO_DELETE_RECORDS = "errore nella cancellazione di record dal file di archivio";
   $QMAKECGIQ_ASK_DELETE      = "Confermi cancellazione dei record dal file di archivio ?";
   $QMAKECGIQ_QUERY_REPORT    = "Risultati della ricerca";
   $QMAKECGIQ_NO_RECORD_FOUND = "Spiacente, la vostra ricerca non ha trovato record";
   $QMAKECGIQ_DELETED         = "Trovati e cancellati";

   $DATE          = "data";
   $QUESTIONS     = "domande";
   $TIME          = "tempo";
   $TIME_ELAPSED  = "tempo impiegato";
   $MARK          = "voto";
   $RIGHT_ANSWERS = "risposte esatte";
   $WRONG         = "errate";
   $UNMARKED      = "non valutate";
   $LIST_OF_ANSWERS = "Lista delle risposte";
   $AUTHOR        = "Autore";
   $EXCLUDED      = "Esclusa";
   $QUIZ_TITLE    = "Titolo quiz";
   $ARCHIVE_NAME  = "Nome file di archivio";
   $STUDENT_NAME  = "Nome esaminando";
   $FROM_DATE     = "Dalla data";
   $TO_DATE       = "Alla data";
   $QUERY_RESULT  = "Risultari ricerca";
   $SEARCH        = "Ricerca";
   $CLOSE         = "Chiudi";
   $HELP          = "Aiuto";
   $FOUND         = "Trovati";
   $RESULTS       = "Risultati";
   $RECORDS_UP_TO = "Visualizza al massimo record:";
   $RECORDS       = "record";
   $DELETE        = "Elimina";
   $PRINT         = "Stampa";
   $PRINT_MSG     = "Seleziona il menu FILE , quindi STAMPA...";
   $PASSWORD      = "Password";
   $QUESTION      = "Domanda";
   $ANSWERS       = "Risposte";
   $CORRECT_ANS   = "Risposte corrette";
   $GLOB_STATS    = "Statistiche globali";
   $MAX           = "Valore massimo";
   $MIN           = "Valore minimo";
   $MEAN          = "Valore medio";
   $STD_DEV       = "Deviazione standard";
   $EXACT_MATCH   = "Corrispondenza esatta";
   $ENABLE_GLOB_STATS = 'Abilita statistiche globali (tempo, voto)';
   $WEIGHT        = "Peso";
   $POINTS        = "punti";
   $ON            = "su";
   $HOURS_MINUTES = "ore:min:sec";
   $SHORT_REPORT  = "Report sintetico";
   $BASE_10       = "riportato a base 10";
   $NEXT_RESULTS  = "Prossimi risultati >>";
   $PREV_RESULTS  = "<< Precedenti risultati";
 }
}

#---------------------------
# Main
#---------------------------

# mode  : action to do on archive (search, delete, deleteAll)
# field : name of record field (title,user...) 
# archive : archive file name
# password : if archive is encrypted, you need a password to decrypt data

  $lang = $cgivars->param('lang'); 
  SetLanguage($lang);

  $server_url = $cgivars->url;

  $mode = $cgivars->param('mode'); 
  if ($mode eq '') {
    printError($QMAKECGIQ_MODE_MISSING);
    die();
  }

  $archive = $cgivars->param('logfile');
  if ($archive eq '') {
    printError($QMAKECGIQ_LOGFILE_MISSING);
    die();
  }
  $filename = $file_path.$archive;

  $value  = $cgivars->param('value');
  $value2 = $cgivars->param('value2');
  $value3 = $cgivars->param('value3');
  $dataListFieldName = $cgivars->param('data_list');

  $name_exact = ($cgivars->param('name_exact') eq 'on')?1:0;
  $quiz_exact = ($cgivars->param('quiz_exact') eq 'on')?1:0;
  $data_exact = ($cgivars->param('data_exact') eq 'on')?1:0;

  $global_stats = ($cgivars->param('global_stats') eq 'on')?1:0;
  $short_report = ($cgivars->param('short_report') eq 'on')?1:0;

  $noPwd = 0;
  $password = $cgivars->param('pwd');
  if ($password eq '') {
    $noPwd = 1;
  }
  else {
    @keyword = MakeKey($password);
  }

  $from_index = $cgivars->param('from_index');
  $max_records = $cgivars->param('max_records');
  if ($max_records<=0) {
    $max_records = 1000;
  }

  getDateFromTo();

  if ($mode eq 'search') {
    if (Search()==-1) {
      printError($QMAKECGIQ_NO_OPEN_FILE."<BR>".$filename);
      die();
    }
  }
  elsif ($mode eq 'delete') {
    if (Delete()!=1) {
      printError($QMAKECGIQ_NO_DELETE_RECORDS);
      die();
    }
  }
  elsif ($mode eq 'init') {
    # read archive file and returs @listQuiz, @listName and @listData
    if (ReadListOfQuizTitle()==-1) {
      printError($QMAKECGIQ_NO_OPEN_FILE."<BR>".$filename);
      die();
    }
    Init();
  }
  elsif ($mode eq 'help') {
    GetListOfQuizTitle();
    Init();
  }
  else {
    printError($QMAKECGIQ_CMD_UNKNOWN);
  }


#-----------------------------
# Subroutine getDateFromTo()   
#-----------------------------
sub getDateFromTo
{
  $from_day   = $cgivars->param('from_day');
  $from_month = $cgivars->param('from_month');
  $from_year  = $cgivars->param('from_year');
  $to_day     = $cgivars->param('to_day');
  $to_month   = $cgivars->param('to_month');
  $to_year    = $cgivars->param('to_year');
  
  $date_from = '';
  $date_to = '';

# verifica anno composto da cifre e non lettere

  if (($from_day ne '--')&&($from_month ne '--')&&
      ($from_day ne '')&&($from_month ne '')&&($from_year ne '')) {
    $day = ($from_day<10)?"0$from_day":"$from_day";
    $month = ($from_month<10)?"0$from_month":"$from_month";
    $date_from = "$from_year-$month-$day";
  }
  if (($to_day ne '--')&&($to_month ne '--')&&
      ($to_day ne '')&&($to_month ne '')&&($to_year ne '')) {
    $day = ($to_day<10)?"0$to_day":"$to_day";
    $month = ($to_month<10)?"0$to_month":"$to_month";
    $date_to = "$to_year-$month-$day";
  }
}


#-----------------------------
# Subroutine compareDateFromTo()   
#-----------------------------
sub compareDateFromTo
{
  my $date = shift;
  @date_vett = split (/-/,$date);
  $date = $date_vett[2]."-".$date_vett[1]."-".$date_vett[0];

  if (($date_to ne '')&&($date_from ne '')) {
    return (($date ge $date_from)&&($date le $date_to));
  }
  elsif ($date_to ne '') {
    return ($date le $date_to);
  }
  elsif ($date_from ne '') {
    return ($date ge $date_from);
  }
  return 1;
}

#-----------------------------
# Subroutine printAnswers()   
#-----------------------------
sub printAnswers
{
  my @data = @_;

  my $time_str;

  $time_str = GetTimeString($time);

  print "$TIME_ELAPSED = $time_str $HOURS_MINUTES<BR>\n";
  print "$MARK = $mark/$maxmark<BR>\n";
  print "$RIGHT_ANSWERS = $nRight, $WRONG = $nWrong, $UNMARKED = $nOpenAns<BR>\n";

  if ($short_report == 1) {
    print "<HR>\n";
    return;
  }

  print "<I>$LIST_OF_ANSWERS</I>:<BR>\n";

  print "<TABLE BORDER=1>";
  print "<TR><TH>$QUESTION</TH>";
  print "<TH>$WEIGHT</TH>" if ($code>=2);
  print "<TH>$ANSWERS</TH>";
  print "<TH>$CORRECT_ANS</TH></TR>";

  for ($i=0; $i<$maxQuest ; $i++) {
    print "<TR><TD>".($i+1)."</TD>";
    $typeOfQuest = shift(@data);

    if ($typeOfQuest == $$QMAKE_OPENANS) {
      if (($encrypt==1)&&($noPwd==0)) {
        if ($code>=2) {
          $weight = DecryptString(shift(@data));
        }
        $openAns = DecryptString(shift(@data));
      }
      else {
        if ($code>=2) {
          $weight = shift(@data);
        }
        $openAns = shift(@data);
      }
      if ($openAns eq '') {
        $openAns = '&nbsp';
      }
      print "<TD>$weight</TD>" if ($code>=2);
      print "<TD COLSPAN=2>$openAns</TD>";
    }
    elsif (($typeOfQuest == $$QMAKE_MULTIANS)|| 
           ($typeOfQuest == $$QMAKE_MULTIANSPT)||
           ($typeOfQuest == $$QMAKE_BOOLEAN)||
           ($typeOfQuest == $$QMAKE_MATCHING)||
           ($typeOfQuest == $$QMAKE_FILLGAP)) {
      if (($encrypt==1)&&($noPwd==0)) {
        if ($code>=2) {
          $weight = DecryptString(shift(@data));
        }
        $risposte = DecryptString(shift(@data));
        $score    = DecryptString(shift(@data));
      }
      else {
        if ($code>=2) {
          $weight = shift(@data);
        }
        $risposte = shift(@data);
        $score = shift(@data);
      }
      if ($risposte eq '') {
        $risposte = '&nbsp';
      }
      print "<TD>$weight</TD>" if ($code>=2);
      print "<TD>$risposte</TD>";
      if ($code<2) {
         print "<TD>$score</TD>";
      }
      else {
        @scores = split(/,/,$score);
        if ($typeOfQuest == $$QMAKE_MULTIANSPT) {
          print "<TD>$POINTS $scores[0] , $scores[1] $MARK</TD>";
        }
        else {
          print "<TD>$scores[0] $ON $scores[1]</TD>";
        }
      }
    }
    else {
      print "<TD></TD>" if ($code>=2);
      print "<TD COLSPAN=2>$EXCLUDED</TD>";
    }
    print "</TR>\n";
  }

  print "</TABLE><HR>\n";
}


#-----------------------------
# Subroutine printUserResult()   
#-----------------------------
sub printUserResult
{
  my @data = @_;
  if ($userName ne '') {
    print "<B>$userName</B><BR>\n";
  }
  if (($code>=3)&&($userData ne '')) {
    print "$userData<BR>\n";
  }
  printAnswers(@data);
}


#-----------------------------
# Subroutine printQuizResult()   
#-----------------------------
sub printQuizResult
{
  my @data = @_;

  print "<B>$quizName</B><BR>\n";
  print "$DATE=$dateQuiz, $QUESTIONS=$maxQuest, $TIME=$timeout min.<P>\n";

  printAnswers(@data);
}


#-----------------------------
# Subroutine printGlobalStats()
#-----------------------------
sub printGlobalStats
{
  my $i = 0;

  my $max_mark = $mark_vett[0];
  my $min_mark = $mark_vett[0];
  my $stddev_mark = 0;
  my $mean_mark = 0;

  my $max_time = $time_vett[0];
  my $min_time = $time_vett[0];
  my $stddev_time = 0;
  my $mean_time = 0;

  my $max_time2 = $time_vett2[0];
  my $min_time2 = $time_vett2[0];
  my $stddev_time2 = 0;
  my $mean_time2 = 0;

  for ($i=0; $i<@mark_vett; $i++) {

    if ($mark_vett[$i]<$min_mark) {
      $min_mark = $mark_vett[$i];
    }
    if ($mark_vett[$i]>$max_mark) {
      $max_mark = $mark_vett[$i];
    }

    if ($time_vett[$i]<$min_time) {
      $min_time = $time_vett[$i];
    }
    if ($time_vett[$i]>$max_time) {
      $max_time = $time_vett[$i];
    }

    if ($time_vett2[$i]<$min_time2) {
      $min_time2 = $time_vett2[$i];
    }
    if ($time_vett2[$i]>$max_time2) {
      $max_time2 = $time_vett2[$i];
    }

    $mean_mark += $mark_vett[$i];
    $mean_time += $time_vett[$i];
    $mean_time2 += $time_vett2[$i];
  }

  $mean_mark = $mean_mark / @mark_vett;
  $mean_time = $mean_time / @time_vett;
  $mean_time2 = $mean_time2 / @time_vett2;

  for ($i=0; $i<@mark_vett; $i++) {
    $stddev_mark += (($mark_vett[$i] - $mean_mark)**2);
    $stddev_time += (($time_vett[$i] - $mean_time)**2);
    $stddev_time2 += (($time_vett2[$i] - $mean_time2)**2);
  }
  $stddev_mark = sqrt($stddev_mark / @mark_vett);
  $stddev_time = sqrt($stddev_time / @time_vett);
  $stddev_time2 = sqrt($stddev_time2 / @time_vett2);

  my $realMeanTime   = GetTimeString($mean_time2);
  my $realMaxTime    = GetTimeString($max_time2);
  my $realMinTime    = GetTimeString($min_time2);
  my $realStdDevTime = GetTimeString($stddev_time2);

  my $relativeMeanTime   = int ($mean_time * 1000) / 1000;
  my $relativeMaxTime    = int ($max_time * 1000) / 1000;
  my $relativeMinTime    = int ($min_time * 1000) / 1000;
  my $relativeStdDevTime = int ($stddev_time * 1000) / 1000;

  my $devstdApprox = int ($stddev_mark * 1000) / 1000;

  print <<STAT_TABLE
  <BR><BR>
  <TABLE BORDER=1 WIDTH=100%>

    <TR><TH COLSPAN=4 BGCOLOR='$COLOR1'>$GLOB_STATS</TH></TR>

    <TR><TD WIDTH=25%></TD><TD WIDTH=25%><I>$MARK ($BASE_10)</I></TD><TD WIDTH=25%><I>$TIME ($HOURS_MINUTES)</I></TD><TD WIDTH=25%><I>$TIME (%)</I></TD></TR>
    <TR><TD><I>$MEAN</I></TD>   <TD>$mean_mark</TD>     <TD>$realMeanTime</TD>   <TD>$relativeMeanTime</TD></TR>
    <TR><TD><I>$MAX</I></TD>    <TD>$max_mark</TD>      <TD>$realMaxTime</TD>    <TD>$relativeMaxTime</TD></TR>
    <TR><TD><I>$MIN</I></TD>    <TD>$min_mark</TD>      <TD>$realMinTime</TD>    <TD>$relativeMinTime</TD></TR>
    <TR><TD><I>$STD_DEV</I></TD><TD>$devstdApprox</TD>   <TD>$realStdDevTime</TD> <TD>$relativeStdDevTime</TD></TR>

  </TABLE>
STAT_TABLE
;
}

#-----------------------------
# Subroutine Init()
#-----------------------------
sub Init
{
  PrintHeader();
  PrintSearchPanel();
  PrintHelp();
  print "</FORM>";
  print "</body></html>\n";
}

#-----------------------------
# Subroutine PrintHelp()   
#-----------------------------
sub PrintHelp
{
 if (($lang eq 'eng')||($lang eq '')) {

  print <<HELP_TEXT
<BR><BR>
<FONT FACE='Arial' SIZE=-2><B>Query Criteria</B>
<HR>
<B>Query by quiz title</B>
<BR>
Type the title of quiz in the "Quiz Title" form field or select it from the list of quiz title:
its name will be automatically appear on the above text field.<BR>
You can also specified a incomplete title. They will show all the quizzes which their title contains the
word typed in the text field. If you wish search only the exact quiz title, check the box "Exact Matching".<BR>
The student name field can be void. 
<BR><BR>
<B>Query by student name</B>
<BR>
The same criterion of quiz title. The student name can be the exact name, a partially name or choosen from the
list of student name.
<BR><BR>
<B>Query by quiz title and student name</B>
<BR>
You can mix the rules either for "query by quiz title" and "query by student name" in order to refine your
query criterion.<BR>
For example you could search all quizzes that contains "Mathematical" as part of quiz name (so you can find
"Mathematical quiz" as well "Geometrical and Mathematical exercises") for all students which name start
with "S" ("Scott", "Smith", "Stevenson", ....)
</FONT>
HELP_TEXT
;
  }
  elsif ($lang eq 'ita') {

  print <<HELP_TEXT_ITA
<BR><BR>
<FONT FACE='Arial' SIZE=-2><B>Criterio di ricerca</B>
<HR>
<B>Ricerca per titolo quiz</B>
<BR>
Inserisci il titolo del quiz nella casella di testo "Titolo quiz" o selezionalo dalla lista dei titoli:
il nome apparir automaticamente nella casella di testo superiore.<BR>
E' possibile anche specificare un titolo incompleto. Verranno ricercati tutti i quiz il cui nome contiene
la parola immessa nella casella di testo. Se si desidera ricercare un titolo esatto di quiz, cliccare sulla casella "Corrispondenza esatta".<BR>
Il campo "Nome esaminando" pu restare vuoto. 
<BR><BR>
<B>Ricerca per nome esaminando</B>
<BR>
Stesso criterio di ricerca per titolo quiz. Il nome dell'esaminando pu essere il nome esatto, un nome parziale
o scelto dalla lista dei nomi degli esaminandi.
<BR><BR>
<B>Ricerca per titolo quiz e nome esaminando</B>
<BR>
E' possibile utilizzare entrambe le regole di "ricerca per titolo quiz" e "ricerca per nome esaminando" 
allo scopo di raffinare il criterio di ricerca.<BR>
Per esempio  possibile ricercare tutti i quiz che contengono "Matematica" come parte del nome del quiz
(cos verr trovato "Quiz di Matematica" cos pure "Esercizi di Geometria e Matematica")
per tutti gli esaminandi il cui nome inizia con "R" ("Rossi", ...)
</FONT>
HELP_TEXT_ITA
;

  }
}

#---------------------------
# Subroutine Search()
#---------------------------
sub Search
{
  my $nRecords = 0;
  my $index = 0;

  my $i = 0;
  my @record_list;
  my $list_of_records = '';

  my $check_quiz = 0;
  my $check_name = 0;
  my $check_data = 0;

  # used during the parsing of @user_vett
  my $nRow = 0;
  my $fieldname;
  my $fieldvalue;

  GetListOfQuizTitle();

  if (open (FP, "+<$filename")==0) {
    return -1;
  }

  PrintHeader();
  PrintSearchPanel();

  print "<BR><HR><FONT FACE='Arial' SIZE=-1><B>$QMAKECGIQ_QUERY_REPORT</B></FONT><HR>\n";

  while (($line = <FP>)&&($nRecords < $max_records)) {

    @data = readRecord($line,$password);

    if ((compareDateFromTo($dateQuiz))&&($index >= $from_index)) {

        # match quiz title field
        if ($quiz_exact==1) {
          $check_quiz = ($quizName eq $value);
        }
        else {
          $_ = $quizName;
          $check_quiz = ((m/\Q$value\E/)||($quizName eq $value));
        }

        # match user name field
        if ($name_exact==1) {
          $check_name = ($userName eq $value2);
        }
        else {
          $_ = $userName;
          $check_name = ((m/\Q$value2\E/)||($userName eq $value2));
        }

        # match "other data" field

        for ($nRow=0; $nRow<@user_vett; $nRow++) {
          @myrow = split (/=/,@user_vett[$nRow]);
          $fieldname = shift(@myrow);
          $fieldvalue = shift(@myrow);
          if ($fieldname eq $dataListFieldName) {
            if ($data_exact==1) {
              $check_data = ($fieldvalue eq $value3);
            }
            else {
              $_ = $fieldvalue;
              $check_data = ((m/\Q$value3\E/)||($fieldvalue eq $value3));
            }
            last;
          }
        }


        if ( (($check_quiz)||($value eq '*')||($value eq '')) &&
             (($check_name)||($value2 eq '*')||($value2 eq '')) &&
             (($check_data)||($value3 eq '*')||($value3 eq '')) ) {

            if ($nRecords==0) {
              print "<INPUT TYPE='BUTTON' VALUE='$DELETE' OnClick='deleteRecords()' style='font-family:Arial'>";
              print "<INPUT TYPE='BUTTON' VALUE='$PRINT' OnClick='printWindow()' style='font-family:Arial'><HR>\n";
            }

            printTitle();
            printUserResult(@data);
            push(@record_list, $index);
            $mark_vett[$nRecords] = $mark/$maxmark*10;
            $time_vett[$nRecords] = ($time/60)/$timeout*100;
            $time_vett2[$nRecords] = $time;

            $nRecords++;
        }
    }  # end if compareDateFromTo
    $index++;
  }  # end while

  if ($nRecords >= $max_records) {
    $from_index = $index;
  }
  else {
    $from_index = 0;
  }
print <<SET_FROM_INDEX
  <SCRIPT LANGUAGE='JavaScript'>
  <!--
  document.query.from_index.value = '$from_index';
  //-->
  </SCRIPT>
SET_FROM_INDEX
;

  if ($nRecords==0) {
    print "<FONT FACE='Arial' SIZE=-1>$QMAKECGIQ_NO_RECORD_FOUND</FONT><BR>";
  }
  else {
    print "<FONT FACE='Arial' SIZE=-1>$FOUND $nRecords $RESULTS</FONT><BR>";
  }

  if ($from_index>0) {
    # there are more results
    print "<INPUT TYPE='BUTTON' VALUE='$NEXT_RESULTS' onClick='nextResults()' style='font-family:Arial; font-size:14;font-weight:bold'>";
  }

  # print global statistics
  if (($global_stats)&&($nRecords>0)) {
    printGlobalStats();
  }

  # sets in a hidden field the list of record index found
  for ($i=0; $i<$nRecords; $i++) {
    $list_of_records = $list_of_records.$record_list[$i].",";
  }
  $list_of_records = $list_of_records."-1";

print <<SET_RECORD_LIST
  <SCRIPT LANGUAGE='JavaScript'>
  <!--
  document.query.record_list.value = '$list_of_records';
  //-->
  </SCRIPT>
SET_RECORD_LIST
;
  print "</FORM></body></html>\n";

  close(FP);
  return $nRecords;
}

#---------------------------
# Subroutine Delete()   
#---------------------------
sub Delete
{
  my $sel_index = 0;
  my $index = 0;
  my $nDeleted = 0;
  my $line = '';

  my $str = $cgivars->param('record_list');

  my @record_list = split (/,/,$str);

  if (open (SOURCE, "+<$filename")==0) {
    return -1;
  }
  if (open (DEST, "+>$LOG_TEMPFILE")==0) {
    return -1;
  }

  $sel_index = shift(@record_list);
  while ($line=<SOURCE>) {
    if ($index != $sel_index) {
      print DEST $line;
    }
    else {
      $sel_index = shift(@record_list);
      $nDeleted++;
    }
    $index++;
  }
  close (DEST);
  close (SOURCE);

  unlink $filename;
  rename ($LOG_TEMPFILE,$filename);

  GetListOfQuizTitle();

  PrintHeader();
  PrintSearchPanel();
  print "<BR><HR><FONT FACE='Arial' SIZE=-1><B>$QMAKECGIQ_DELETED $nDeleted $RECORDS</B></FONT><HR><BR>\n";
  print "</FORM>";
  print "</body></html>\n";
  return 1; 
}

#---------------------------
# Subroutine PrintHeader()
#---------------------------
sub PrintHeader
{
print <<HEADER
  Content-type: text/html

  <html>
  <head><title>$QMAKECGIQ_QUERY_REPORT</title></head>
  <STYLE>
  <!--
  BODY { margin-left: 0.5in; margin-right: 0.5in; margin-top: 0.35in; font-family: arial; font-size: 10pt }
  H1   { font-family: arial; font-size: 16pt }
  H2   { font-family: arial; font-size: 14pt }
  H3   { font-family: arial; font-size: 12pt; font-style:italic }
  TD,TR,TH { font-family: arial; font-size: 10pt }
  -->
  </STYLE>
  <SCRIPT LANGUAGE='JavaScript'>
  <!--

  function searchRecord() {
    document.query.from_index.value = 0;
    document.query.mode.value = 'search';
    document.query.submit();
  }

  function nextResults() {
    document.query.mode.value = 'search';
    document.query.submit();
  }

  function changeTitle() {
    var i;
    i = document.query.title_list.selectedIndex;
    document.query.value.value = document.query.title_list.options[i].text;
  }

  function changeUser() {
    var i;
    i = document.query.user_list.selectedIndex;
    document.query.value2.value = document.query.user_list.options[i].text;
  }

  function deleteRecords() {
    var status=0;
    status = window.confirm('$QMAKECGIQ_ASK_DELETE');
    if (status) {
      document.query.mode.value = 'delete';
      document.query.submit();
    }
  }

  function printWindow() {
    var vers = parseInt(navigator.appVersion);
    if (vers >= 4) { window.print(); }
    else { window.alert('$PRINT_MSG'); }
  }

  function getHelp() {
    document.query.mode.value = 'help';
    document.query.submit();
  }

  function selectItem(obj,item) {
    var found=0,i;
    for (i=0; i<obj.length;i++) {
      if (obj.options[i].text==item) {
        obj.options[i].selected = 1;
        found = 1;
      }
    }
    if (found==0)
      obj.options[0].selected = 1;
  }

  function init() {
    selectItem(document.query.title_list,'$value');
    selectItem(document.query.user_list,'$value2');
    selectItem(document.query.from_day,'$from_day');
    selectItem(document.query.from_month,'$from_month');
    selectItem(document.query.to_day,'$to_day');
    selectItem(document.query.to_month,'$to_month');
    document.query.quiz_exact.checked=$quiz_exact;
    document.query.name_exact.checked=$name_exact;
    document.query.global_stats.checked=$global_stats;
    document.query.short_report.checked=$short_report;
  }

  //-->
  </SCRIPT>
  <BODY onLoad="init()">
HEADER
;  
}

#---------------------------
# Subroutine readRecord()
#---------------------------
sub readRecord
{
  my $line = shift;
  my $pw = shift;

  if ($line =~ m/\t/) { 
    # actual separator is tab
    @elems = split (/\t/,$line);
  }
  else {
    # old separator was ;
    @elems = split (/;/,$line);
  }
  $head = shift(@elems); 

  if ($head eq '/QMAKECGI/') {
    # versione uguale alla 1.3
    shift(@elems); 
    $code     = 1;
    $encrypt  = shift(@elems);
    $quizName = shift(@elems);    
  }
  elsif ($head =~ m/:/) {
    # versione 2 o successiva
    $code     = $head;
    $code     =~ s/://;
    $encrypt  = shift(@elems);
    $quizName = shift(@elems);    
  }
  else {
    # versione precedente alla 1.3 
    $quizName = $head;
    $code    = 0;   
    $encrypt = 0;
  } 

  $userName = shift(@elems);
  if ($code>=3) {
    @user_vett = split (/,/,$userName);
    $userName = shift(@user_vett);
    if (@user_vett>1) {
      $userData = join(',',@user_vett);
    }
    else {
      $userData = shift(@user_vett);
    }
    if ($userName eq $userData) {
      $userData = '';
    }
  } 
  $dateQuiz = shift(@elems);
  $maxQuest = shift(@elems);
  $maxmark  = shift(@elems);
  $timeout  = shift(@elems);
  $time     = shift(@elems);

  if (($encrypt==1)&&($noPwd==0)) {
    $nRight  = DecryptString(shift(@elems));
    $nWrong  = DecryptString(shift(@elems));
  }
  else {
    $nRight   = shift(@elems);
    $nWrong   = shift(@elems);
  }
  $nOpenAns = shift(@elems);

  if (($encrypt==1)&&($noPwd==0)) {
    $mark = DecryptString(shift(@elems));
  }
  else {
    $mark = shift(@elems);
  } 
  $author = shift(@elems);
  $argument = shift(@elems);

  return @elems;
}


#---------------------------
# Subroutine printTitle()   
#---------------------------
sub printTitle
{
  my $key_image = $image_path."key.gif";

  print "<TABLE><TD BGCOLOR='#$COLOR1'>";
  if ($encrypt==1) {
    print "<IMG SRC='$key_image' WIDTH=23 HEIGHT=12>&nbsp;&nbsp;";
  }
  print "<FONT FACE='Arial' SIZE=-1><B>$quizName</B>";

  if ($argument ne '') {
    print " ($argument)";
  }
  print "</FONT></TD><TR><TD><FONT FACE='Arial' SIZE=-1>";

  if ($author ne '') {
    print "$AUTHOR=$author ";
  } 
  print "$DATE=$dateQuiz, $QUESTIONS=$maxQuest, $TIME=$timeout min.</FONT></TD></TABLE>\n";
}


#---------------------------
# Subroutine printError()   
#---------------------------
sub printError
{
print $cgivars->header;
print $cgivars->start_html($QMAKECGI_SERVER_ERROR);
print <<TEXT_ERR
      <TABLE><TD BGCOLOR='#$COLOR1'><FONT FACE='Arial'>$QMAKECGI_SERVER_ERROR</FONT></TD></TABLE>
      <FONT FACE='Arial' SIZE='-1'>$QMAKECGI_STR_SERVER_ERR:<BR>
      <B>$_[0]</B>
      </FONT>
      <CENTER><BR><FORM><INPUT TYPE='BUTTON' VALUE='Close' OnClick='top.close()' style='font-family:Arial'></FORM></CENTER>
TEXT_ERR
;
print $cgivars->end_html;
}


#---------------------------
# Subroutine PrintSearchPanel()
#---------------------------
sub PrintSearchPanel
{
  my $quizOptionTag = GetOptionTag('title_list','changeTitle',1,'',@listQuiz);
  my $nameOptionTag = GetOptionTag('user_list','changeUser',1,'',@listName);
  my $dataOptionTag = GetOptionTag('data_list','',0,$dataListFieldName,@listData);

  $top_image = $image_path."topimage.jpg";

print <<SEARCH_PANEL_1

  <FORM NAME='query' ACTION='$server_url' METHOD='POST'>

  <INPUT TYPE='hidden' NAME='mode' VALUE='$mode'>
  <INPUT TYPE='hidden' NAME='field' VALUE='$field'>
  <INPUT TYPE='hidden' NAME='logfile' VALUE='$archive'>
  <INPUT TYPE='hidden' NAME='record_list' VALUE=''>
  <INPUT TYPE='hidden' NAME='lang' VALUE='$lang'>
  <INPUT TYPE='hidden' NAME='from_index' VALUE='$from_index'>

  <BR>
  <CENTER>
  <TABLE BORDER=1 BGCOLOR='#$COLOR1'>

    <TR>
      <TD BGCOLOR='#$COLOR1' ALIGN='center' COLSPAN=2><A HREF='http://www.lucagalli.net/'><IMG SRC='$top_image' BORDER=0></A></TD>
    </TR>

    <TR>
      <TD WIDTH=270 BGCOLOR='#$COLOR1' ALIGN='right' VALIGN='TOP'><FONT FACE='Arial' SIZE=-1><B>$ARCHIVE_NAME </B></FONT></TD>
      <TD BGCOLOR='#$COLOR1'>$archive</TD>
    </TR>

    <TR>
      <TD WIDTH=270 BGCOLOR='#$COLOR1' ALIGN='right' VALIGN='TOP'><FONT FACE='Arial' SIZE=-1><B>$QUIZ_TITLE </B></FONT></TD>
      <TD BGCOLOR='#$COLOR1'><INPUT TYPE='text' NAME ='value' SIZE=25 VALUE='$value'><BR>
      $quizOptionTag<BR>
      <INPUT TYPE="CHECKBOX" NAME="quiz_exact">$EXACT_MATCH</TD>
    </TR>

    <TR>
      <TD WIDTH=270 BGCOLOR='#$COLOR1' ALIGN='right' VALIGN='TOP'><FONT FACE='Arial' SIZE=-1><B>$STUDENT_NAME </B></FONT></TD>
      <TD BGCOLOR='#$COLOR1'><INPUT TYPE='text' NAME ='value2' SIZE=25 VALUE='$value2'><BR>
      $nameOptionTag<BR>
      <INPUT TYPE="CHECKBOX" NAME="name_exact">$EXACT_MATCH</TD>
    </TR>

SEARCH_PANEL_1
;

    if (@listData > 1) {
      print "<TR>";
      print "<TD WIDTH=270 BGCOLOR='#$COLOR1' ALIGN='right' VALIGN='TOP'><FONT FACE='Arial' SIZE=-1>";
      print "$dataOptionTag</FONT></TD>";
      print "<TD BGCOLOR='#$COLOR1'><INPUT TYPE='text' NAME ='value3' SIZE=25 VALUE='$value3'><BR>";
      print "<INPUT TYPE='CHECKBOX' NAME='data_exact'>$EXACT_MATCH</TD>";
      print "</TR>";
    }

print <<SEARCH_PANEL_2

    <TR>
      <TD WIDTH=270 BGCOLOR='#$COLOR1' ALIGN='right'><FONT FACE='Arial' SIZE=-1><B>$FROM_DATE </B></FONT></TD>
      <TD BGCOLOR='#$COLOR1'>
      <SELECT NAME='from_day'><OPTION SELECTED>--<OPTION>1<OPTION>2<OPTION>3<OPTION>4<OPTION>5<OPTION>6<OPTION>7<OPTION>8<OPTION>9<OPTION>10<OPTION>11<OPTION>12<OPTION>13<OPTION>14<OPTION>15<OPTION>16<OPTION>17<OPTION>18<OPTION>19<OPTION>20<OPTION>21<OPTION>22<OPTION>23<OPTION>24<OPTION>25<OPTION>26<OPTION>27<OPTION>28<OPTION>29<OPTION>30<OPTION>31</SELECT>
      <SELECT NAME='from_month'><OPTION SELECTED>--<OPTION>1<OPTION>2<OPTION>3<OPTION>4<OPTION>5<OPTION>6<OPTION>7<OPTION>8<OPTION>9<OPTION>10<OPTION>11<OPTION>12</SELECT>
      <INPUT TYPE='text' NAME ='from_year' SIZE=4 VALUE='$from_year'>
      </TD>
    </TR>

    <TR>
      <TD WIDTH=270 BGCOLOR='#$COLOR1' ALIGN='right'><FONT FACE='Arial' SIZE=-1><B>$TO_DATE </B></FONT></TD>
      <TD BGCOLOR='#$COLOR1'>
      <SELECT NAME='to_day'><OPTION SELECTED>--<OPTION>1<OPTION>2<OPTION>3<OPTION>4<OPTION>5<OPTION>6<OPTION>7<OPTION>8<OPTION>9<OPTION>10<OPTION>11<OPTION>12<OPTION>13<OPTION>14<OPTION>15<OPTION>16<OPTION>17<OPTION>18<OPTION>19<OPTION>20<OPTION>21<OPTION>22<OPTION>23<OPTION>24<OPTION>25<OPTION>26<OPTION>27<OPTION>28<OPTION>29<OPTION>30<OPTION>31</SELECT>
      <SELECT NAME='to_month'><OPTION SELECTED>--<OPTION>1<OPTION>2<OPTION>3<OPTION>4<OPTION>5<OPTION>6<OPTION>7<OPTION>8<OPTION>9<OPTION>10<OPTION>11<OPTION>12</SELECT>
      <INPUT TYPE='text' NAME ='to_year' SIZE=4 VALUE='$to_year'>
      </TD>
    </TR>

    <TR>
      <TD WIDTH=270 BGCOLOR='#$COLOR1' ALIGN='right'><FONT FACE='Arial' SIZE=-1><B>$RECORDS_UP_TO</B></FONT></TD>
      <TD BGCOLOR='#$COLOR1'><INPUT TYPE='text' NAME ='max_records' SIZE=5 VALUE='$max_records'></TD>
    </TR>

    <TR>
      <TD WIDTH=270 BGCOLOR='#$COLOR1' ALIGN='right' VALIGN='TOP'><FONT FACE='Arial' SIZE=-1><B>$PASSWORD </B></FONT></TD>
      <TD BGCOLOR='#$COLOR1'><INPUT TYPE='password' NAME ='pwd' SIZE=20 VALUE='$password'></TD>
    </TR>

    <TR>
      <TD BGCOLOR='#$COLOR1' ALIGN='center' COLSPAN=2><FONT FACE='Arial' SIZE=-1>
        <INPUT TYPE='checkbox' NAME ='global_stats'>$ENABLE_GLOB_STATS
        <INPUT TYPE='checkbox' NAME ='short_report'>$SHORT_REPORT
      </FONT></TD>
    </TR>

    <TR>
      <TD COLSPAN=2 ALIGN='CENTER' BGCOLOR='#$COLOR2'>
      <INPUT TYPE='button' VALUE='$SEARCH' onClick='searchRecord()' style='font-family:Arial; font-size:14;font-weight:bold'>
      <INPUT TYPE='button' VALUE='$CLOSE' onClick='self.close()' style='font-family:Arial; font-size:14;font-weight:bold'>
      <INPUT TYPE='button' VALUE='$HELP' onClick='getHelp()' style='font-family:Arial; font-size:14;font-weight:bold'>
      </TD>
    </TR>

  </TABLE>
  </CENTER>

SEARCH_PANEL_2
;
  PrintListOfQuizTitle();
}


#--------------------------------
# Subroutine ReadListOfQuizTitle()
#--------------------------------
sub ReadListOfQuizTitle
{
  my $foundQuiz = 0;
  my $foundName = 0;
  my $foundData = 0;
  my $nQuiz = 0;
  my $nName = 0;
  my $nData = 0;
  my $line = '';
  my $i = 0;
  my $nRow = 0;
  my $fieldname;

  if (open (FP, "+<$filename")==0) {
    return -1;
  }

  while($line=<FP>) {

    readRecord($line,$password);

    # append "quiz title" to the quiz title list
    $foundQuiz = 0;
    for ($i=0; $i<$nQuiz; $i++) {
      if ($listQuiz[$i] eq $quizName) {
        $foundQuiz = 1;
        last;
      }
    }
    if ($foundQuiz==0) {
      @listQuiz[$nQuiz] = $quizName;
      $nQuiz++;
    }

    # append "user name" to the user name list
    $foundName = 0;
    for ($i=0; $i<$nName; $i++) {
      if ($listName[$i] eq $userName) {
        $foundName = 1;
        last;
      }
    }
    if ($foundName==0) {
      @listName[$nName] = $userName;
      $nName++;
    }

    # append "other user data" to the user data list
    for ($nRow=0; $nRow<@user_vett; $nRow++) {
      @myrow = split (/=/,@user_vett[$nRow]);
      $fieldname = shift(@myrow);
      $foundData = 0;
      for ($i=0; $i<@listData; $i++) {
        if (@listData[$i] eq $fieldname) {
          $foundData = 1;
          last;
        }
      }
      if ($foundData==0) {
        @listData[$nData] = $fieldname;
        $nData++;
      }
    }
  }
  close(FP);

  @listQuiz = sort(@listQuiz);
  @listName = sort(@listName);
  @listData = sort(@listData);

  return 1;
}

#----------------------------------
# Subroutine PrintListOfQuizTitle()
#----------------------------------
sub PrintListOfQuizTitle
{
 my $strQuizzes = '';
 my $strNames = '';
 my $strDatas = '';
 my $i = 0;

 for ($i=0; $i<@listQuiz; $i++) {
   $strQuizzes = $strQuizzes.$listQuiz[$i];
   if ($i<@listQuiz-1) {
     $strQuizzes = $strQuizzes."\t";
   } 
 }
 for ($i=0; $i<@listName; $i++) {
   $strNames = $strNames.$listName[$i];
   if ($i<@listName-1) {
     $strNames = $strNames."\t";
   }
 }

 for ($i=0; $i<@listData; $i++) {
   $strDatas = $strDatas.$listData[$i];
   if ($i<@listData-1) {
     $strDatas = $strDatas."\t";
   }
 }

print <<LIST_OF_QUIZZES
  <INPUT TYPE='hidden' NAME ='list_quiz' VALUE='$strQuizzes'>
  <INPUT TYPE='hidden' NAME ='list_name' VALUE='$strNames'>
  <INPUT TYPE='hidden' NAME ='list_data' VALUE='$strDatas'>
LIST_OF_QUIZZES
;
}


#----------------------------------
# Subroutine GetOptionTag()
#----------------------------------
sub GetOptionTag
{
  my $name = shift;
  my $fn_name = shift;
  my $empty_line = shift;
  my $selected_item = shift;
  my @vett = @_;

  my $str = '';
  my $i=0;

  if ($fn_name eq '') {
    $str = "<SELECT NAME='$name' SIZE=1>";
  }
  else {
    $str = "<SELECT NAME='$name' SIZE=1 OnChange='$fn_name()'>";
  }

  if ($empty_line == 1) {
    # add the first empty line
    $str = $str.'<OPTION>';
  }

  for ($i=0; $i<@vett; $i++) {
    if ($selected_item eq '') {
      # no default selection
      $str = $str.'<OPTION>'.$vett[$i];
    }
    else {
      # there is a default selection
      if ($vett[$i] eq $selected_item) {
        $str = $str.'<OPTION SELECTED>'.$vett[$i];
      }
      else {
        $str = $str.'<OPTION>'.$vett[$i];
      }
    }
  }
  $str = $str.'</SELECT>';
  return $str;
}

#--------------------------------
# Subroutine GetListOfQuizTitle()
#--------------------------------
sub GetListOfQuizTitle
{
  my $list_quiz = $cgivars->param('list_quiz');
  my $list_name = $cgivars->param('list_name');
  my $list_data = $cgivars->param('list_data');

  @listQuiz = split (/\t/,$list_quiz);
  @listName = split (/\t/,$list_name);
  @listData = split (/\t/,$list_data);
}


#----------------------------------
# Subroutine MakeKey()   
#----------------------------------
sub MakeKey
{
  my $input_key = shift;
  my $i = 0;
  my @keyword;

  if ($input_key eq '') {
    $input_key = 'syskey';
  } 
  @keyword = unpack("C*",$input_key);
  for ($i=0; $i<@keyword; $i++) {
    if (($keyword[$i]>=65)&&($keyword[$i]<=90)) {  
      $keyword[$i] -= 65;
    }
    elsif (($keyword[$i]>=97)&&($keyword[$i]<=122)) { 
      $keyword[$i] -= 97;
    }
    else {
      $keyword[$i] = 0;
    }
  }
  return @keyword;
}

#----------------------------------
# Subroutine DecryptString()   
#----------------------------------
sub DecryptString 
{
  my $str = shift;
  my $i = 0;
  my $j = 0;
  my $c = 0;
  my $n = 0;
  my @decode;

  @str_vett = unpack("C*",$str);
  $n = @keyword;
  for ($i=0; $i<@str_vett; $i+=3) {
    if ($str_vett[$i]==32) { $str_vett[$i]=48; }
    if ($str_vett[$i+1]==32) { $str_vett[$i+1]=48; }
    if ($str_vett[$i+2]==32) { $str_vett[$i+2]=48; }
    $c = ($str_vett[$i]-48)*100+($str_vett[$i+1]-48)*10+($str_vett[$i+2]-48);
    $decode[$j] =  $c - $keyword[$j % $n];
    $j++;
  }
  return pack("C*",@decode);
}


#--------------------------------
# Subroutine GetTimeString()
#--------------------------------
sub GetTimeString
{
  my $mytime = shift;

  my $hour = int($mytime / 3600);
  my $resto = $mytime % 3600;
  my $min = int ($resto / 60);
  my $sec = $resto % 60;
  my $time_str;

  if ($hour<=9) {
    $time_str = "0$hour:";
  }
  else {
    $time_str = "$hour:";
  }
  if ($min<=9) {
    $time_str = $time_str."0$min:";
  }
  else {
    $time_str = $time_str."$min:";
  }
  if ($sec<=9) {
    $time_str = $time_str."0$sec";
  }
  else {
    $time_str = $time_str."$sec";
  }
  return $time_str;
}

