#!/usr/bin/perl
$file_path = '/usr/local/vhosts/your_directory/';


##############################################################################
# QmakeCGITopView.pl            Version 1.0                                  #
# Copyright 2001 Luca Galli     info@lucagalli.net                           #
# Last Modified: 29/09/2001                                                  #
# The latest version of this script can be found at http://www.lucagalli.net #
##############################################################################
# If you run into any problems while trying to configure this scripts,       #
# read the document "How to install a Perl script" at:                       #
#        http://www.lucagalli.net/eng/quizfaber/perl-install.htm             #
# I hope I will be able to help you solve your problems.                     #
##############################################################################
# QmakeCGITop.pl store quizzes marks on archive file placed on web server.   #
# Each single quiz, that runs on a single PC in a Internet/Intranet,         #
# automatically sends its results through the net to web server.             #
# Then the server calls a script, called 'QmakeCGITop.pl' that collect this  # 
# marks into a archive file.                                                 #
# For each data sent from a single quiz, a text line is added to top chart   #
# file.                                                                      #
#                                                                            #
# How to use this script can also be read on QuizFaber Help                  #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2001 Luca Galli                                                  #
#                                                                            #
# QmakeCGITopView.pl be used and modified free of charge by anyone so long as#
# this copyright notice and the comments above remain intact.                #
# Selling the code for this program is forbidden.                            #
#                                                                            #
# THIS PROGRAM IS GIVEN "AS IS" AND WITHOUT WARRANTIES AS TO PERFORMANCE OR  #
# MERCHANTABILITY OR ANY OTHER WARRANTIES WHETHER EXPRESSED OR IMPLIED.      #
# NO WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.                #
# IN NO EVENT SHALL LUCA GALLI BE LIABLE FOR ANY DAMAGES WHATSOEVER          #
# INCLUDING DIRECT, INDIRECT, INCIDENTAL, CONSEQUENTIAL, LOSS OF BUSINESS    #
# PROFITS OR SPECIAL DAMAGES, EVEN IF LUCA GALLI BEEN ADVISED OF THE         #
# POSSIBILITY OF SUCH DAMAGES.                                               #
##############################################################################

use CGI;

$cgivars = new CGI;

$COLOR1 = 'CFCFCF';

#---------------------------
# Subroutine SetLanguage() 
#---------------------------
sub SetLanguage
{
 my $lang = shift;

 if ($lang eq 'ita') {
   $QMAKECGI_SERVER_ERROR     = 'Errore Script CGI';
   $QMAKECGI_STR_SERVER_ERR   = 'Lo script QmakeCGITopView.pl ha prodotto il seguente errore';
   $QMAKECGI_LOGFILE_MISSING  = "nome del file di archivio non specificato";
   $TITLE = "Classifica migliori ".$nVisibleRecord;
   $header_name ="Nome";
   $header_score="Punteggio";  
 }
 else {
   $QMAKECGI_SERVER_ERROR     = 'CGI Script error';
   $QMAKECGI_STR_SERVER_ERR   = 'The CGI script named QmakeCGITopView.pl has produced the follow error';
   $QMAKECGI_LOGFILE_MISSING  = "archive file name missing";
   $TITLE = "Top ".$nVisibleRecord." results";
   $header_name ="Name";
   $header_score="Score";
 }
}

#---------------------------
# Main   
#---------------------------

  $nVisibleRecord  = $cgivars->param('visible');

  $lang            = $cgivars->param('lang'); 
  SetLanguage($lang);

  $archive = $cgivars->param('logfile');
  if ($archive eq '') {
    printError($QMAKECGI_LOGFILE_MISSING);
    die();
  }

  printTopChart();


#---------------------------
# Subroutine printResult()   
#---------------------------
sub printTopChart
{
  my $nRecords = 0; 

  print $cgivars->header;

  $filename = $file_path.$archive;

  if (open (FP, "+<$filename")==0) {
    print $cgivars->start_html($TITLE);
    print $cgivars->end_html;
    return 0;
  }

  print <<TEXT_TOP
    <HTML>
    <HEAD>
    <STYLE>
    <!--
     TH,B { font-family:Arial; font-size:10pt; font-weight:bold; }
     TD   { font-family:Arial; font-size:10pt; }
    // -->
    </STYLE>
    </HEAD>
    <BODY>
    <CENTER>
    <B>$TITLE</B>
    <TABLE BORDER=0 CELLSPACING=10>
    <TR>
    <TH></TH>
    <TH ALIGN='LEFT'>$header_name</TH>
    <TH ALIGN='LEFT'>$header_score</TH>
    </TR>
TEXT_TOP
;

  while (($line = <FP>)&&($nRecords < $nVisibleRecord)) {
    @elems = split (/\t/,$line);
    print "<TR>";
    print "<TD>".($nRecords+1).".</TD>";
    print "<TD>".$elems[2]."</TD>";
    print "<TD>".$elems[3]."</TD>";
    print "</TR>";
    $nRecords++;
  }

  print <<TEXT_BOTTOM
    </TABLE></CENTER>
TEXT_BOTTOM
;

  close(FP);
  print $cgivars->end_html;
  return 1;
}


#---------------------------
# Subroutine printError()   
#---------------------------
sub printError
{
  print $cgivars->header;
  print $cgivars->start_html($QMAKECGI_SERVER_ERROR);
  print <<TEXT_ERR      
      <TABLE><TD BGCOLOR='#$COLOR1'><FONT FACE='Arial'>$QMAKECGI_SERVER_ERROR</FONT></TD></TABLE>
      <FONT FACE='Arial' SIZE='-1'>$QMAKECGI_STR_SERVER_ERR:<BR>
      <B>$_[0]</B>
      </FONT>
TEXT_ERR
;
  print $cgivars->end_html;
}
